<?php
/*
Plugin Name: Grafiki w SERPach 
Plugin URI: http://marketingdlaludzi.pl
Description: Dzięki wtyczce możliwe jest wzbogacenie wyświetlanego w wyszukiwarce Google opisu artykułu o grafikę oraz jej podpis.
Author: Bartosz Sikorski
Version: 1.0
Author URI: http://sbart.pl
*/


global $sbart_img_serp_version;
$sbart_img_serp_version = "1.0";

function sbart_img_serp_install() 
{
   global $wpdb;
   global $sbart_img_serp_version;

   $table_name = $wpdb->prefix . "serp_img";
      
   $sql = "CREATE TABLE $table_name (
  id INT NOT NULL AUTO_INCREMENT PRIMARY KEY,
  post_id VARCHAR(255) DEFAULT '' NOT NULL,
  status BOOLEAN NOT NULL DEFAULT '0',
  UNIQUE KEY id (id))
  CHARACTER SET utf8 COLLATE utf8_general_ci;";
	
	require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
	dbDelta($sql);
	
	add_option("sbart_img_serp_version", '1.0');
	add_option("sbart_img_serp_new_version", '1.0');
	add_option("sbart_img_serp_new_version_url", 'http://marketingdlaludzi.pl/do-pobrania/');
	add_option("sbart_img_serp_prefiks", 'Na grafice:');
	add_option("sbart_img_serp_domyslny_opis", 'Polecany artykuł!');
	add_option("sbart_img_serp_data_sprawdzenia_wersji", '');
	add_option("sbart_img_serp_strony_statyczne", 0);
	add_option("sbart_img_serp_wyswietlanie_zawsze", 1);
	add_option("sbart_img_serp_wyswietlanie_decyduj", 0);
}


function sbart_img_serp_uninstall()
{
    global $wpdb;

	$table_name = $wpdb->prefix . "serp_img";
	$sql = 'DROP TABLE ' . $table_name;
    $wpdb->query($sql);
    
	delete_option("sbart_img_serp_version");
	delete_option("sbart_img_serp_new_version");
	delete_option("sbart_img_serp_new_version_url");
    delete_option("sbart_img_serp_prefiks");
    delete_option("sbart_img_serp_domyslny_opis");
	delete_option("sbart_img_serp_data_sprawdzenia_wersji");
	delete_option("sbart_img_serp_strony_statyczne");
	delete_option("sbart_img_serp_wyswietlanie_zawsze");
	delete_option("sbart_img_serp_wyswietlanie_decyduj");
}

function stan_checbox_rs($parametr)
{
	if($parametr == 1) 
		return "checked=\"checked\"";
	else
		return "";
}

// Opcje wtyczki

function sbart_img_serp_options() 
{
	if (!current_user_can( 'manage_options'))  
	{
		wp_die( __( 'Nie masz uprawnień by korzystać z tej strony.'));
	}
	if(isset($_POST['zapisz']))
	{
		update_option('sbart_img_serp_prefiks', $_POST['prefiks']);
		update_option('sbart_img_serp_strony_statyczne', $_POST['strony_statyczne']);
		if($_POST['kiedy_wyswietlac']==0)
		{
			update_option('sbart_img_serp_wyswietlanie_zawsze', 1);
			update_option('sbart_img_serp_wyswietlanie_decyduj', 0);

		}
		elseif($_POST['kiedy_wyswietlac']==1)
		{
			update_option('sbart_img_serp_wyswietlanie_zawsze', 0);
			update_option('sbart_img_serp_wyswietlanie_decyduj', 1);
		}
		else
		{
			update_option('sbart_img_serp_wyswietlanie_zawsze', 1);
			update_option('sbart_img_serp_wyswietlanie_decyduj', 0);
		}
	}
?>
	<div class="wrap">
		<div id="icon-plugins" class="icon32"><br/></div>
		<h2>Grafiki w SERPach - opcje</h2>
		<form style="margin-top:20px" method="post">
			<p>Wyświetlanie:</p>
			<div style="margin-left:30px">
				<p><input type="radio" name="kiedy_wyswietlac" value="0" <?php echo stan_checbox_rs(get_option('sbart_img_serp_wyswietlanie_zawsze')) ?>/> zawsze wyświetlaj grafiki</p>
				<p><input type="radio" name="kiedy_wyswietlac" value="1"<?php echo stan_checbox_rs(get_option('sbart_img_serp_wyswietlanie_decyduj')) ?> /> decyduj przy publikacji dla których postów wyświetlać grafiki</p>
			</div>
			<p style="margin-top:20px"><input type="checkbox" value="1" name="strony_statyczne" <?php echo stan_checbox(get_option('sbart_img_serp_strony_statyczne')) ?>> Wyświetlaj grafiki także dla stron statycznych.</p>
			<p>Prefiks opisu grafiki: <input name="prefiks" type="text" value="<?php echo get_option("sbart_img_serp_prefiks");?>"></p>
			<p>Domyślny opis grafiki: <input name="domyslny_opis" type="text" value="<?php echo get_option("sbart_img_serp_domyslny_opis");?>"> <i>(wyświetlany bez prefiksu przy barku opisu ALT obrazka)</i></p>
			
			<input name="zapisz" type="submit" value="Zapisz">
			<p style="margin-top:30px"><strong>Informacje o wtyczce:</strong></p>
			<ul style="list-style-type:disc;margin-left:20px;font-size:11px">
				<li>wtyczka pobiera pierwszy w kolejności obrazek dostępny w galerii danego artykułu,</li>
				<li>opis grafiki, to opis ALT obrazka,</li>
				<li>jeśli na stronie zainstalowana jest inna wtyczka służąca do wyświetlania fragmentów rozszerzonych, wtedy grafiki mogą nie być uwzględniane w wynikach wyszukiwania,</li>
				<li>w zależności od serwisu, okres oczekiwania na pojawienie sie grafik w wynikach wyszukiwania może wynosić od kilku dni do kilku tygodni,</li>
				<li>często, jako pierwsze w wynikach wyszukiwania pojawiają się tylko opisy, a dopiero po kilku dniach grafiki,</li>
				<li>do testowania, czy wtyczka działa poprawnie oraz czy nie koliduje z innymi fragmentami rozszerzonymi, najlepiej korzystać z narzędzia: <a href="http://www.google.com/webmasters/tools/richsnippets" target="_blank">Google Structured Data Testing Tool</a>.</li>
			</ul>
			<p style="margin-top:20px"><strong>Przykład:</strong></p>
			<img src="/wp-content/plugins/grafiki-w-serpach/przyklad.png">
		</form>
	</div>
<?php
}

// Link do opcji pluginu

function sbart_img_serp_settings_link($links) 
{ 
	$settings_link = '<a href="options-general.php?page=sbart-img-serp">Opcje</a>'; 
	array_unshift($links, $settings_link); 
	return $links; 
}
  
function sbart_img_serp_sprawdz_wersje()
{
	$aktualna_data = date("Y-m-d");
	if(get_option('sbart_img_serp_data_sprawdzenia_wersji') != $aktualna_data)
	{
		update_option('sbart_img_serp_data_sprawdzenia_wersji',$aktualna_data);
		//sprawdzamy czy jest nowa wersja wtyczki
		
		$blog = str_replace("=","",base64_encode(get_settings('siteurl')));
		ini_set('display_errors', 'Off');
		ini_set('display_startup_errors', 'Off');
		error_reporting(0);
		$xml_parse = simplexml_load_file("http://sbart.pl/sbart-img/".$blog.".xml");
		
		$dane = $xml_parse->parametr;
		$tablica = "";
		foreach ($dane AS $parametr_index => $parametr_obj)
		{
			$tablica['wersja'] = strval($parametr_obj->wersja);
			$tablica['strona_wtyczki'] = strval($parametr_obj->url);
		}
		if(isset($tablica['wersja']) && trim($tablica['wersja'])!="")
		{
			update_option('sbart_img_serp_new_version',$tablica['wersja']);
		}
		if(isset($tablica['strona_wtyczki']) && trim($tablica['strona_wtyczki'])!="")
		{
			update_option('sbart_img_serp_new_version_url',$tablica['strona_wtyczki']);
		}
	}
	if(get_option('sbart_img_serp_version') != get_option('sbart_img_serp_new_version'))
	{
		add_action('admin_notices', 'sbart_img_serp_nowa_wersja');
	}
}

function sbart_img_serp_nowa_wersja()
{
    echo '<div class="updated"><p>Dostępna jest nowa wersja wtyczki <strong>Grafiki w SERPach</strong>. Pobierz <a href="'.get_option('sbart_img_serp_new_version_url').'"><strong>tutaj</strong></a>.</p></div>';
}

function sbart_img_serp_add_custom_box() 
{
    add_meta_box( 
        'sbart_img_serp_sectionid',
        __( 'Grafiki w SERPach', 'indeksacja_textdomain' ),
        'sbart_img_serp_inner_custom_box',
        'post',
		'side',
		'high'
    );  
}

function sbart_img_serp_inner_custom_box( $post ) 
{
	wp_nonce_field( plugin_basename( __FILE__ ), 'sbart_img_serp_noncename' );
	global $wpdb;
	$table_name = $wpdb->prefix."serp_img";
	$czy_wyswietlac = $wpdb->get_var( "SELECT status FROM $table_name WHERE post_id = ".$post->ID);
	if(isset($czy_wyswietlac))
	{
		echo '<p><input type="checkbox" name="czy_wyswietlac" value="1" '.stan_checbox($czy_wyswietlac).'/> Wyświetlaj grafikę w SERPach.</p>';
	}
	else
	{
		echo '<p><input type="checkbox" name="czy_wyswietlac" value="1" checked="checked"/> Wyświetlaj grafikę w SERPach.</p>';
	}
}

function sbart_img_serp_save_postdata( $post_id ) 
{
	global $wpdb;
	if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) 
		return;

	if ( !wp_verify_nonce( $_POST['sbart_img_serp_noncename'], plugin_basename( __FILE__ ) ) )
		return;
		
	if ( 'page' == $_POST['post_type'] ) 
	{
		if ( !current_user_can( 'edit_page', $post_id ) )
			return;
	}
	else
	{
		if ( !current_user_can( 'edit_post', $post_id ) )
			return;
	}

	$czy_wyswietlac = $_POST['czy_wyswietlac'];
	
	$table_name = $wpdb->prefix."serp_img";
	if(get_post_status( $post_id ) != "inherit")
	{
		$czy_istnieje = $wpdb->get_var( "SELECT status FROM $table_name WHERE post_id = ".$post_id);
		if(isset($czy_istnieje))
		{
			$wpdb->update($wpdb->prefix."serp_img", array('status' => $czy_wyswietlac), array( 'post_id' => $post_id));
		}
		else
		{
			$wpdb->insert( $wpdb->prefix."serp_img", array( 'post_id' => $post_id, 'status' => $czy_wyswietlac));
		}
	}
}


//instalacja wtyczki
register_activation_hook(__FILE__,'sbart_img_serp_install');

//usuwanie wtyczki
register_deactivation_hook(__FILE__, 'sbart_img_serp_uninstall');


//podstrony w menu
function sbart_img_serp_opcje_wtyczki() 
{
	add_options_page('Grafiki w SERPach', 'Grafiki w SERPach', 'manage_options', 'sbart-img-serp', 'sbart_img_serp_options' );
}
add_action('admin_menu', 'sbart_img_serp_opcje_wtyczki');

function get_first_img() 
{
	global $post;
	$photos = get_children( array('post_parent' => $post->ID, 'post_status' => 'inherit', 'post_type' => 'attachment', 'post_mime_type' => 'image', 'order' => 'ASC', 'orderby' => 'menu_order ID') );
	if ($photos) 
	{
		$photo = array_shift($photos);
		$img[0] = wp_get_attachment_image_src($photo->ID);
		$img[1] = trim(strip_tags( get_post_meta($photo->ID, '_wp_attachment_image_alt', true) ));
		return $img;
	}
return false;
}

function sbart_img_serp_post($content) 
{
		global $post;
		$image = get_first_img();
		global $wpdb;
		$table_name = $wpdb->prefix."serp_img";
		if(get_option('sbart_img_serp_wyswietlanie_decyduj') == 1)
		{
			$czy_wyswietlac = $wpdb->get_var( "SELECT status FROM $table_name WHERE post_id = ".$post->ID);
		}
		if(!isset($czy_wyswietlac) || $czy_wyswietlac == 1)
		{
			if((get_post_type( $post->ID )=="page" && get_option('sbart_img_serp_strony_statyczne')==1) || get_post_type( $post->ID )=="post")
			{
				if(isset($image[0][0]))
				{
					if(!isset($image[1]) || trim($image[1])=="")
					{
						$opis_grafiki = trim(get_option('sbart_img_serp_domyslny_opis'));
					}
					else
					{
						$opis_grafiki = trim(get_option("sbart_img_serp_prefiks").' '.$image[1]);
					}
					$snippet = '<div itemscope itemtype="http://schema.org/Recipe">
						<meta itemprop="name" content="'.$post->post_title.'">
						<meta itemprop="image" content="'.$image[0][0].'"/>
						<meta itemprop="prepTime" content="'.$opis_grafiki.'">
						<meta itemprop="ingredients" content="'.$post->post_title.'">
					</div>';
				}
				else
				{
					preg_match_all('/<img[^>]+>/i',$content, $result);
					//echo $result[0][0];
					preg_match('/src=("[^"]*")/i',$result[0][0], $img_src);
					preg_match('/alt=("[^"]*")/i',$result[0][0], $img_alt);
					//print_r($img);
					$opis_grafiki = str_replace("\"","",trim($img_alt[1]));
					if(!isset($opis_grafiki) || $opis_grafiki=="")
					{
						$opis_grafiki = trim(get_option('sbart_img_serp_domyslny_opis'));
					}
					else
					{
						$opis_grafiki = trim(get_option("sbart_img_serp_prefiks").' '.$opis_grafiki);
					}
					$snippet = '<div itemscope itemtype="http://schema.org/Recipe">
						<meta itemprop="name" content="'.$post->post_title.'">
						<meta itemprop="image" content="'.str_replace("\"","",trim($img_src[1])).'"/>
						<meta itemprop="prepTime" content="'.$opis_grafiki.'">
						<meta itemprop="ingredients" content="'.$post->post_title.'">
					</div>';
				}
			}
		}
		else
		{
			echo $snippet="";
		}
		
		return $content.$snippet;
	
}

if(!is_home() && !is_archive() && !is_author() && !is_category() && !is_feed() && !is_search() && !is_tag() && !is_paged() && !is_page())
{
		add_filter('the_content','sbart_img_serp_post');
}

//dodaj link do opcji wtyczki
$plugin = plugin_basename(__FILE__); 
add_filter("plugin_action_links_$plugin", 'sbart_img_serp_settings_link' );

//sprawdź aktualną wersję
sbart_img_serp_sprawdz_wersje();

if(get_option('sbart_img_serp_wyswietlanie_decyduj') == 1)
{
	// dodaj box przy publikacji artykułu
	add_action( 'add_meta_boxes', 'sbart_img_serp_add_custom_box' );
	// uaktualnij ustawienia przy zapisie artykułu
	add_action( 'save_post', 'sbart_img_serp_save_postdata' );
}

?>